import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;

public class AnagramFinderTest {

	public static void main(String[] args) throws IOException {
		boolean failed = false;
		ByteArrayOutputStream os = new ByteArrayOutputStream();
		PrintStream out = System.out;
		System.setOut(new PrintStream(os));

		String[][] expected = {{"fist", "moot"}, {"ace", "glen", "helm"}, 
				{"adios", "runs"}};
		String[] queries = {"most of it", "challenge me", "dinosaurs"};
		
		for (int i = 0; i < expected.length; ++i) {
			os.reset();
			AnagramFinder.main(new String[] { "resources//dictionary.txt",
					queries[i] });

			String resultStr = os.toString().trim();
			String[] result = resultStr.split("\\s+");
			
			Arrays.sort(result);
			
			if (!DictionaryHelperTest.areArraysEqual(result, expected[i])) {
				failed = true;
				out.println("AnagramFinder.main exmaple " + i
						+ " failed");
			}
		}

		if (!failed)
			out.println("AnagramFinder Question Passed");
	}
}
