import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;

public class DictionaryHelperTest {

	public static boolean areArraysEqual(String[] a, String[] b) {
		if (b == null || a.length != b.length)
			return false;

		for (int i = 0; i < a.length; ++i)
			if (!a[i].equals(b[i]))
				return false;

		return true;
	}

	public static void main(String[] args) throws IOException {
		String[] dictionary = { "madam", "modem", "radar", "anagram",
				"interim", "cycled", "cycles", "cyclic" };

		boolean failed = false;
		String[][] expected = { { "madam", "modem" }, { "anagram", "interim" },
				{ "cycled", "cycles", "cyclic" } };
		String[] patterns = { "m-d-m", "-n--r-m", "cycl--" };

		for (int i = 0; i < expected.length; ++i)
			if (!areArraysEqual(expected[i],
					DictionaryHelper.findMatches(patterns[i], dictionary))) {
				failed = true;
				System.out.println("DictionaryHelper.findMatches exmaple " + i
						+ " failed");
			}

		ByteArrayOutputStream os = new ByteArrayOutputStream();
		PrintStream out = System.out;
		System.setOut(new PrintStream(os));

		for (int i = 0; i < expected.length; ++i) {
			os.reset();
			DictionaryHelper.main(new String[] { "resources//dictionary.txt", patterns[i]});

			String[] result = os.toString().split("\r?\n");
			if (!areArraysEqual(expected[i], result)) {
				failed = true;
				out.println("DictionaryHelper.main exmaple " + i
						+ " failed");
			}
		}

		if (!failed)
			out.println("DictionaryHelper Question Passed");
	}
}
