public class HangmanTest {

	private static boolean verify(Hangman game, String guess, String misses,
			boolean isOver) {
		return guess.equals(game.getGuess()) && misses.equals(game.getMisses())
				&& game.isOver() == isOver;
	}

	public static void main(String[] args) {

		Hangman game = new Hangman("Hello");
		String[] guesses = { "-----", "h----", "h----", "h----", "h----",
				"h-ll-", "h-ll-", "hell-", "hello" };
		String[] misses = { "", "", "a", "ar", "acr", "acr", "acpr", "acpr",
				"acpr" };
		boolean[] over = { false, false, false, false, false, false, false,
				false, true };

		char[] letters = { ' ', 'h', 'a', 'r', 'c', 'l', 'p', 'e', 'o' };
		boolean failed = false;

		for (int i = 0; i < guesses.length; ++i) {
			game.guessLetter(letters[i]);
			if (!verify(game, guesses[i], misses[i], over[i])) {
				System.out.println("Hangman example " + i + " failed");
				failed = true;
			}
		}

		if (!failed)
			System.out.println("Hangman class code passed");
	}
}
